VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMiniM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim HostName As String
Dim PortNumber As String
Dim NameSpace As String

Public Property Get Host() As String
  Host = HostName
End Property
Public Property Let Host(ByVal NewValue As String)
  HostName = NewValue
End Property

Public Property Get Port() As String
  Port = PortNumber
End Property
Public Property Let Port(ByVal NewValue As String)
  PortNumber = NewValue
End Property

Public Property Get ZNSpace() As String
  ZNSpace = NameSpace
End Property

Private Sub Class_Initialize()
  On Error GoTo Err_Initialize
  HostName = "localhost"
  PortNumber = "5000"
  NameSpace = "%SYS"
  'Set Wsck = CreateObject("MSWinsock.Winsock", "Wsck_")
  IsConnect = False
  IsData = False
  MiniMMetod = DoNotSet
  'frmCnct.Wsck(0).LocalPort = 0
  'frmCnct.Wsck(0).Protocol = 0
  GoTo Ext_Initialize
Err_Initialize:
  MsgBox "When MiniM.Initialize Error number " & Err.Number & vbCrLf & Err.Description, vbExclamation, "Object Initialize Error"
  Resume Ext_Initialize
Ext_Initialize:
End Sub

Private Sub Class_Terminate()
  frmCnct.Wsck.Close
  Sleep 100
  DoEvents
End Sub

Public Function Connect() As Boolean
  Dim i As Integer
  On Error GoTo Err_Connect
  Connect = False
  IsData = False
  SerRsp = ""
  frmCnct.Wsck.Close
  frmCnct.Wsck.RemoteHost = HostName
  frmCnct.Wsck.RemotePort = PortNumber
  frmCnct.Wsck.Connect
  For i = 1 To 1200
    Sleep 100
    If frmCnct.Wsck.State = sckConnected Then
      IsConnect = True
      Exit For
    End If
    DoEvents
  Next i
  MiniMMetod = Connecting
  Do While Not IsData  'Wait SerRsp
    Sleep 100
    DoEvents
  Loop
  Connect = True
  GoTo Ext_Connect
Err_Connect:
  MsgBox "When MiniM.Connect Error number " & Err.Number & vbCrLf & Err.Description, vbExclamation, "Connect Error"
  Resume Ext_Connect
Ext_Connect:
End Function

Public Function Disconnect() As Boolean
  Dim i As Integer
  On Error GoTo Err_Disconnect
  Disconnect = False
  IsData = False
  SerRsp = ""
  frmCnct.Wsck.Close
  For i = 1 To 1200
    DoEvents
    Sleep 100
    If frmCnct.Wsck.State = sckClosed Then
      IsConnect = False
      Exit For
    End If
  Next i
  MiniMMetod = DoNotSet
  Disconnect = True
  GoTo Ext_Disconnect
Err_Disconnect:
  MsgBox "When MiniM.Disconnect Error number " & Err.Number & vbCrLf & Err.Description, vbExclamation, "Connect Error"
  Resume Ext_Disconnect
Ext_Disconnect:
End Function

Public Function Xecute(strForRun As String) As String
  On Error GoTo Err_Xecute
  IsData = False
  MiniMMetod = RunString
  frmCnct.Wsck.SendData "t" & Chr(0) & Len(strForRun) & Chr(0) & strForRun
  Do While Not IsData
    Sleep 100
    DoEvents
  Loop
  IsData = False
  Xecute = SerRsp
  GoTo Ext_Xecute
Err_Xecute:
  MsgBox "When MiniM.Xecute Error number " & Err.Number & vbCrLf & Err.Description, vbExclamation, "Xecute Error"
  Resume Ext_Xecute
Ext_Xecute:
End Function

Public Function GetValue(strVarName As String) As String
  On Error GoTo Err_GetValue
  IsData = False
  MiniMMetod = GetBinaryData
  frmCnct.Wsck.SendData "r" & Chr(0) & Len(strVarName) & Chr(0) & strVarName
  Do While Not IsData
    Sleep 100
    DoEvents
  Loop
  IsData = False
  GetValue = SerRsp
  GoTo Ext_GetValue
Err_GetValue:
  MsgBox "When MiniM.GetValue Error number " & Err.Number & vbCrLf & Err.Description, vbExclamation, "Xecute Error"
  Resume Ext_GetValue
Ext_GetValue:
End Function

Public Function ChangeNameSpace(sZNSpace As String) As Boolean
  Dim x As String
  On Error GoTo Err_ChangeNameSpace
  ChangeNameSpace = False
  IsData = False
  MiniMMetod = RunString
  x = "ZN """ & sZNSpace & """"
  frmCnct.Wsck.SendData "t" & Chr(0) & Len(x) & Chr(0) & x
  Do While Not IsData
    Sleep 100
    DoEvents
  Loop
  IsData = False
  x = "W $ZNSPACE"
  frmCnct.Wsck.SendData "t" & Chr(0) & Len(x) & Chr(0) & x
  Do While Not IsData
    Sleep 100
    DoEvents
  Loop
  IsData = False
  If SerRsp = sZNSpace Then NameSpace = SerRsp
  ChangeNameSpace = True
  GoTo Ext_ChangeNameSpace
Err_ChangeNameSpace:
  MsgBox "When ChangeNameSpace Error number " & Err.Number & vbCrLf & Err.Description, vbExclamation, "ChangeNameSpace Error"
  Resume Ext_ChangeNameSpace
Ext_ChangeNameSpace:
End Function


